#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

# Require > Squeeze for alsa-utils >= 1.0.25.

rebuild () {
    tar xjf alsa-utils-1.0.25.tar.bz2
    cd alsa-utils-1.0.25
    ./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var \
	    --disable-nls --disable-alsaconf
    make -C amixer
    gcc -o amixer/amixer amixer/amixer.o -lasound
    make -C alsamixer
    gcc -o alsamixer/alsamixer alsamixer/*.o -Wl,-Bstatic -lform -lmenu \
	    -lpanel -lncurses -ltinfo -lgpm -Wl,-Bdynamic -lasound
    strip -R .note -R .comment amixer/amixer alsamixer/alsamixer
    mkdir -p ../amixer/bin ../alsamixer/bin
    cp amixer/amixer ../amixer/bin/
    cp alsamixer/alsamixer ../alsamixer/bin/
    cd ..
    rm -rf alsa-utils-1.0.25
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
